SystemOrganization addCategory: #SUnitGUI!

Object subclass: #TestRunner
	instanceVariableNames: 'categories categoriesSelected classes classesSelected failedList failedSelected errorList errorSelected lastUpdate result previousRun'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUnitGUI'!

!TestRunner commentStamp: '<historical>' prior: 0!
<lint: #ignore rule: #classNotReferenced rational: 'this view is only accessed from menus'>

!

!TestRunner class methodsFor: 'instance-creation' stamp: ''!
build
	^ ToolBuilder build: self new! !

!TestRunner class methodsFor: 'initialization' stamp: ''!
initialize
	self registerInWorldMenu; registerInToolsFlap! !

!TestRunner class methodsFor: 'instance-creation' stamp: ''!
open
	^ ToolBuilder open: self new! !

!TestRunner class methodsFor: 'initialization' stamp: ''!
registerInToolsFlap
	self environment
		at: #Flaps
		ifPresent: [:t1 | t1 registerQuad: #(#TestRunner #build 'SUnit Runner' 'A production scale test-runner.' ) forFlapNamed: 'Tools';
				 replaceToolsFlap]! !

!TestRunner class methodsFor: 'initialization' stamp: ''!
registerInWorldMenu
	self environment
		at: #TheWorldMenu
		ifPresent: [:t1 | t1
				registerOpenCommand: (Array
						with: 'Test Runner'
						with: (Array with: self with: #open))]! !

!TestRunner methodsFor: 'accessing' stamp: ''!
baseClass
	^ TestCase! !

!TestRunner methodsFor: 'processing' stamp: ''!
basicRunSuite: t1 do: t2 
	self basicSetUpSuite: t1.
	[t1 name isEmptyOrNil
		ifTrue: [t1 tests do: t2]
		ifFalse: [t1 tests do: t2 displayingProgress: t1 name]]
		ensure: [self basicTearDownSuite: t1]! !

!TestRunner methodsFor: 'processing' stamp: ''!
basicSetUpSuite: t1 
	t1 resources
		do: [:t2 | t2 isAvailable
				ifFalse: [t2 signalInitializationError]]! !

!TestRunner methodsFor: 'processing' stamp: ''!
basicTearDownSuite: t1 
	t1 resources
		do: [:t2 | t2 reset]! !

!TestRunner methodsFor: 'accessing-classes' stamp: 'marcus.denker 8/24/2008 13:20'!
browseReferencedClasses
	| references |
	references := classesSelected gather: [ :class |
		class methods , class class methods gather: [ :method |
			method literals
				select: [ :each | each isVariableBinding and: [ each value isBehavior ] ]
				thenCollect: [ :each | each value ] ] ].
	(self browserEnvironment new forClasses: references asSet)
		label: 'Referenced Classes';
		openEditor.! !

!TestRunner methodsFor: 'accessing-classes' stamp: 'marcus.denker 8/24/2008 13:21'!
browseSentMessages
	| references |
	references := classesSelected gather: [ :class |
		class methods , class class methods gather: [ :method |
			(method literals copyWithoutAll: class allSelectors , class class allSelectors)
				select: [ :each | each isSymbol ] ] ].
	self systemNavigation
		browseAllImplementorsOfList: references asSet
		title: 'Sent Messages'.! !

!TestRunner methodsFor: 'accessing-classes' stamp: ''!
browseTestClasses
	(self browserEnvironment new forClasses: classesSelected asSet) label: 'Test Classes';
		 openEditor! !

!TestRunner methodsFor: 'private' stamp: ''!
browserEnvironment
	^ Smalltalk classNamed: #BrowserEnvironment! !

!TestRunner methodsFor: 'building' stamp: ''!
buildButtonsWith: t1 
	^ t1 pluggablePanelSpec new model: self;
		 layout: #horizontal;
		
		children: (self buttons
				collect: [:t2 | t1 pluggableButtonSpec new model: self;
						 label: t2 first;
						 action: t2 second;
						 enabled: t2 third;
						 yourself]);
		 yourself! !

!TestRunner methodsFor: 'building' stamp: ''!
buildCategoriesWith: t1 
	^ t1 pluggableMultiSelectionListSpec new model: self;
		 list: #categoryList;
		 menu: #categoryMenu:;
		 getIndex: #categorySelected;
		 setIndex: #categorySelected:;
		 getSelectionList: #categoryAt:;
		 setSelectionList: #categoryAt:put:;
		 yourself! !

!TestRunner methodsFor: 'building' stamp: ''!
buildClassesWith: t1 
	^ t1 pluggableMultiSelectionListSpec new model: self;
		 list: #classList;
		 menu: #classMenu:;
		 getIndex: #classSelected;
		 setIndex: #classSelected:;
		 getSelectionList: #classAt:;
		 setSelectionList: #classAt:put:;
		 yourself! !

!TestRunner methodsFor: 'building' stamp: ''!
buildErrorListWith: t1 
	^ t1 pluggableListSpec new model: self;
		 name: 'Error List';
		 list: #errorList;
		 getIndex: #errorSelected;
		 setIndex: #errorSelected:;
		 yourself! !

!TestRunner methodsFor: 'building' stamp: ''!
buildFailureListWith: t1 
	^ t1 pluggableListSpec new model: self;
		 name: 'Failure List';
		 list: #failedList;
		 getIndex: #failedSelected;
		 setIndex: #failedSelected:;
		 yourself! !

!TestRunner methodsFor: 'building' stamp: ''!
buildStatusWith: t1 
	^ t1 pluggableInputFieldSpec new model: self;
		 color: #statusColor;
		 getText: #statusText;
		 yourself! !

!TestRunner methodsFor: 'building' stamp: ''!
buildWith: t1 
	| t2 |
	t2 := t1 pluggableWindowSpec new model: self;
				 label: self label;
				 extent: self extent;
				 children: (OrderedCollection new add: ((self buildCategoriesWith: t1)
						frame: (0.0 @ 0.0 corner: 0.25 @ 0.92);
						 yourself);
					 add: ((self buildClassesWith: t1)
						frame: (0.25 @ 0.0 corner: 0.5 @ 0.92);
						 yourself);
					 add: ((self buildStatusWith: t1)
						frame: (0.5 @ 0.0 corner: 1.0 @ 0.08);
						 yourself);
					 add: ((self buildFailureListWith: t1)
						frame: (0.5 @ 0.08 corner: 1.0 @ 0.5);
						 yourself);
					 add: ((self buildErrorListWith: t1)
						frame: (0.5 @ 0.5 corner: 1.0 @ 0.92);
						 yourself);
					 add: ((self buildButtonsWith: t1)
						frame: (0.0 @ 0.92 corner: 1.0 @ 1.0);
						 yourself);
					 yourself);
				 yourself.
	^ t1 build: t2! !

!TestRunner methodsFor: 'accessing-ui' stamp: 'GwenaelCasaccio 10/1/2008 22:00'!
buttons
	^ #(( 'Run Selected' #runAll #hasRunnable )
		( 'Run Profiled' #runProfiled #hasRunnable )
		( 'Run Failures' #runFailures #hasFailures )
		( 'Run Errors' #runErrors #hasErrors )
		( 'History' #showHistoryMenu #hasHistory )
		( 'Store result into classes' #storeResultIntoClasses #hasResults )
		( 'Show progress'  #showProgress #hasProgress )).! !

!TestRunner methodsFor: 'accessing-categories' stamp: ''!
categoryAt: t1 
	^ categoriesSelected
		includes: (categories
				at: t1
				ifAbsent: [^ false])! !

!TestRunner methodsFor: 'accessing-categories' stamp: ''!
categoryAt: t1 put: t2 
	categoriesSelected := categoriesSelected
				perform: (t2
						ifTrue: [#copyWith:]
						ifFalse: [#copyWithout:])
				with: (categories
						at: t1
						ifAbsent: [^ self]).
	self changed: #categorySelected;
		 updateClasses! !

!TestRunner methodsFor: 'accessing-categories' stamp: ''!
categoryList
	^ categories! !

!TestRunner methodsFor: 'accessing-categories' stamp: ''!
categoryMenu: t1 
	^ t1 title: 'Categories';
		 add: 'Select all' action: #selectAllCategories;
		 add: 'Select inversion' action: #selectInverseCategories;
		 add: 'Select none' action: #selectNoCategories;
		 addLine;
		 add: 'Filter...' action: #filterCategories;
		 addLine;
		 add: 'Refresh' action: #updateCategories;
		 yourself! !

!TestRunner methodsFor: 'accessing-categories' stamp: ''!
categorySelected
	^ 0! !

!TestRunner methodsFor: 'accessing-categories' stamp: ''!
categorySelected: t1 
	self changed: #categorySelected! !

!TestRunner methodsFor: 'accessing-classes' stamp: ''!
classAt: t1 
	^ classesSelected
		includes: (classes
				at: t1
				ifAbsent: [^ false])! !

!TestRunner methodsFor: 'accessing-classes' stamp: ''!
classAt: t1 put: t2 
	classesSelected := classesSelected
				perform: (t2
						ifTrue: [#copyWith:]
						ifFalse: [#copyWithout:])
				with: (classes
						at: t1
						ifAbsent: [^ self]).
	self changed: #classSelected;
		 changed: #hasRunnable! !

!TestRunner methodsFor: 'accessing-classes' stamp: ''!
classList
	| t1 t2 |
	classes isEmpty
		ifTrue: [^ classes].
	t1 := classes first allSuperclasses size.
	^ classes
		collect: [:t3 | 
			t2 := String new: 2
							* (0 max: t3 allSuperclasses size - t1) withAll: Character space.
			t3 isAbstract
				ifTrue: [t2 asText , t3 name asText addAttribute: TextEmphasis italic;
						 yourself]
				ifFalse: [t2 , t3 name]]! !

!TestRunner methodsFor: 'accessing-classes' stamp: ''!
classMenu: t1 
	| t2 |
	t2 := t1 title: 'Classes';
				 yourself.
	self browserEnvironment notNil
		ifTrue: [t2 add: 'Browse classes' action: #browseTestClasses;
				 add: 'Browse referenced classes' action: #browseReferencedClasses].
	^ t2 add: 'Browse sent messages' action: #browseSentMessages;
		 addLine;
		 add: 'Select all' action: #selectAllClasses;
		 add: 'Select subclasses' action: #selectSubclasses;
		 add: 'Select inversion' action: #selectInverseClasses;
		 add: 'Select none' action: #selectNoClasses;
		 addLine;
		 add: 'Filter...' action: #filterClasses;
		 addLine;
		 add: 'Refresh' action: #updateClasses;
		 yourself! !

!TestRunner methodsFor: 'accessing-classes' stamp: ''!
classSelected
	^ 0! !

!TestRunner methodsFor: 'accessing-classes' stamp: ''!
classSelected: t1 
	self changed: #classSelected! !

!TestRunner methodsFor: 'actions' stamp: ''!
debug: t1 
	self debugSuite: (TestSuite new addTest: t1;
			 yourself)! !

!TestRunner methodsFor: 'actions' stamp: ''!
debugSuite: t1 
	self
		basicRunSuite: t1
		do: [:t2 | t2 debug]! !

!TestRunner methodsFor: 'private' stamp: ''!
defaultBackgroundColor
	^ Color orange! !

!TestRunner methodsFor: 'accessing-testing' stamp: ''!
errorList
	^ errorList
		collect: [:t1 | t1 printString]! !

!TestRunner methodsFor: 'accessing-testing' stamp: ''!
errorSelected
	^ errorList indexOf: errorSelected! !

!TestRunner methodsFor: 'accessing-testing' stamp: ''!
errorSelected: t1 
	errorSelected := errorList at: t1 ifAbsent: nil.
	self changed: #errorSelected.
	errorSelected
		ifNotNil: [self debug: errorSelected]! !

!TestRunner methodsFor: 'accessing-ui' stamp: ''!
extent
	^ 640 @ 480! !

!TestRunner methodsFor: 'accessing-testing' stamp: ''!
failedList
	^ failedList
		collect: [:t1 | t1 printString]! !

!TestRunner methodsFor: 'accessing-testing' stamp: ''!
failedSelected
	^ failedList indexOf: failedSelected! !

!TestRunner methodsFor: 'accessing-testing' stamp: ''!
failedSelected: t1 
	failedSelected := failedList at: t1 ifAbsent: nil.
	self changed: #failedSelected.
	failedSelected
		ifNotNil: [self debug: failedSelected]! !

!TestRunner methodsFor: 'accessing-categories' stamp: ''!
filterCategories
	| t1 |
	t1 := UIManager default request: 'Pattern to select categories:' initialAnswer: '*'.
	t1 isNil
		ifTrue: [^ self].
	categoriesSelected := (categories
				select: [:t2 | t1 match: t2]) asSet.
	self changed: #categorySelected;
		 updateClasses! !

!TestRunner methodsFor: 'accessing-classes' stamp: ''!
filterClasses
	| t1 |
	t1 := UIManager default request: 'Pattern to select tests:' initialAnswer: '*'.
	t1 isNil
		ifTrue: [^ self].
	classesSelected := (classes
				select: [:t2 | t1 match: t2 name]) asSet.
	self changed: #classSelected;
		 changed: #hasRunnable! !

!TestRunner methodsFor: 'utilities' stamp: ''!
findCategories
	| t1 |
	t1 := Set new.
	self baseClass
		withAllSubclassesDo: [:t2 | t2 category
				ifNotNilDo: [:t3 | t1 add: t3]].
	^ Array
		streamContents: [:t4 | Smalltalk organization categories
				do: [:t2 | (t1 includes: t2)
						ifTrue: [t4 nextPut: t2]]]! !

!TestRunner methodsFor: 'utilities' stamp: ''!
findClassesForCategories: t1 
	| t2 |
	t1 isEmpty
		ifTrue: [^ self baseClass withAllSubclasses].
	t2 := t1
				gather: [:t3 | ((Smalltalk organization listAtCategoryNamed: t3)
						collect: [:t4 | Smalltalk at: t4])
						select: [:t4 | t4 includesBehavior: self baseClass]].
	^ t2 asSet! !

!TestRunner methodsFor: 'testing' stamp: ''!
hasErrors
	^ result hasErrors! !

!TestRunner methodsFor: 'testing' stamp: ''!
hasFailures
	^ result hasFailures! !

!TestRunner methodsFor: 'history saving' stamp: 'AlexandreBergel 10/1/2008 11:40'!
hasHistory
	^ true! !

!TestRunner methodsFor: 'history saving' stamp: 'AlexandreBergel 10/21/2008 15:55'!
hasProgress

	| testCaseClasses |

	testCaseClasses := (self suiteAll tests collect: [:testCase | testCase class]) asSet.
	testCaseClasses do: [:cls |
		(cls class methodDictionary includesKey: #lastStoredRun)
			ifTrue: [^ true]].
	^ false! !

!TestRunner methodsFor: 'history saving' stamp: 'GwenaelCasaccio 10/1/2008 22:00'!
hasResults

	^ result notNil! !

!TestRunner methodsFor: 'testing' stamp: ''!
hasRunnable
	^ classesSelected notEmpty! !

!TestRunner methodsFor: 'history saving' stamp: 'AlexandreBergel 10/1/2008 12:00'!
historyMenuList
	^ {'** save current result **'}, (self previousRun collect: [:ts | ts printString])! !

!TestRunner methodsFor: 'initialization' stamp: ''!
initialize
	super initialize.
	failedList := errorList := Array new.
	SystemChangeNotifier uniqueInstance
		notify: self
		ofSystemChangesOfItem: #class
		change: #Added
		using: #update;
		
		notify: self
		ofSystemChangesOfItem: #category
		change: #Added
		using: #update;
		
		notify: self
		ofSystemChangesOfItem: #class
		change: #Removed
		using: #update;
		
		notify: self
		ofSystemChangesOfItem: #category
		change: #Removed
		using: #update;
		
		notify: self
		ofSystemChangesOfItem: #class
		change: #Renamed
		using: #update;
		
		notify: self
		ofSystemChangesOfItem: #category
		change: #Renamed
		using: #update;
		
		notify: self
		ofSystemChangesOfItem: #class
		change: #Recategorized
		using: #update;
		
		notify: self
		ofSystemChangesOfItem: #category
		change: #Recategorized
		using: #update.
	self update; reset! !

!TestRunner methodsFor: 'accessing-ui' stamp: ''!
label
	^ 'Test Runner'! !

!TestRunner methodsFor: 'private' stamp: ''!
label: t1 forSuite: t2 
	^ String
		streamContents: [:t3 | 
			t3 nextPutAll: 'Running ';
				 print: t2 tests size;
				 space;
				 nextPutAll: t1.
			t2 tests size > 1
				ifTrue: [t3 nextPut: $s]]! !

!TestRunner methodsFor: 'private' stamp: ''!
perform: t1 orSendTo: t2 
	^ (self respondsTo: t1)
		ifTrue: [self perform: t1]
		ifFalse: [super perform: t1 orSendTo: t2]! !

!TestRunner methodsFor: 'history saving' stamp: 'AlexandreBergel 10/1/2008 11:46'!
previousRun

	^ previousRun ifNil: [ previousRun := OrderedCollection new ]! !

!TestRunner methodsFor: 'actions' stamp: ''!
reset
	self result: TestResult new;
		 updateResults! !

!TestRunner methodsFor: 'accessing-testing' stamp: ''!
result
	^ result! !

!TestRunner methodsFor: 'accessing-testing' stamp: ''!
result: t1 
	result := t1! !

!TestRunner methodsFor: 'actions' stamp: 'AlexandreBergel 10/21/2008 15:27'!
runAll
	self reset; runSuite: self suiteAll.
	self storeResultIntoClassesUnderName: #lastRun! !

!TestRunner methodsFor: 'actions' stamp: ''!
runErrors
	self result instVarNamed: 'errors' put: OrderedCollection new.
	self runSuite: self suiteErrors! !

!TestRunner methodsFor: 'actions' stamp: ''!
runFailures
	self result instVarNamed: 'failures' put: Set new.
	self runSuite: self suiteFailures! !

!TestRunner methodsFor: 'actions' stamp: ''!
runProfiled
	MessageTally
		spyOn: [self runAll]! !

!TestRunner methodsFor: 'actions' stamp: 'GwenaelCasaccio 10/1/2008 22:03'!
runSuite: aTestSuite
	| |
	
	self basicRunSuite: aTestSuite do: [ :each | self runTest: each ].
	self updateResults

! !

!TestRunner methodsFor: 'actions' stamp: ''!
runTest: t1 
	t1 run: result.
	self updateStatus: true! !

!TestRunner methodsFor: 'accessing-categories' stamp: ''!
selectAllCategories
	categoriesSelected := categories asSet.
	self changed: #categorySelected;
		 updateClasses! !

!TestRunner methodsFor: 'accessing-classes' stamp: ''!
selectAllClasses
	classesSelected := classes asSet.
	self changed: #classSelected;
		 changed: #hasRunnable! !

!TestRunner methodsFor: 'accessing-categories' stamp: ''!
selectInverseCategories
	categoriesSelected := categories asSet removeAll: categoriesSelected;
				 yourself.
	self changed: #categorySelected;
		 updateClasses! !

!TestRunner methodsFor: 'accessing-classes' stamp: ''!
selectInverseClasses
	classesSelected := classes asSet removeAll: classesSelected;
				 yourself.
	self changed: #classSelected;
		 changed: #hasRunnable! !

!TestRunner methodsFor: 'accessing-categories' stamp: ''!
selectNoCategories
	categoriesSelected := Set new.
	self changed: #categorySelected;
		 updateClasses! !

!TestRunner methodsFor: 'accessing-classes' stamp: ''!
selectNoClasses
	classesSelected := Set new.
	self changed: #classSelected;
		 changed: #hasRunnable! !

!TestRunner methodsFor: 'accessing-classes' stamp: ''!
selectSubclasses
	| t1 |
	t1 := self findClassesForCategories: categoriesSelected.
	classesSelected := (classesSelected
				gather: [:t2 | t2 withAllSubclasses
						select: [:t3 | t1 includes: t3]]) asSet.
	self changed: #classSelected;
		 changed: #hasRunnable! !

!TestRunner methodsFor: 'history saving' stamp: 'AlexandreBergel 10/12/2008 11:55'!
showDiffWith: aTestResult
	| string diff |

	diff := result diff: aTestResult.
	string := String streamContents: [:str|
		str nextPutAll: '----------------'; cr.
		str nextPutAll: 'Diff between current result with: ', aTestResult asString; cr.
		str nextPutAll: 'New passed: '.
		diff first do: [:s| str nextPutAll: s printString, ' '].
		str cr.
		str nextPutAll: 'New failures: '.
		diff second do: [:s| str nextPutAll: s printString, ' '].
		str cr.
		
		str nextPutAll: 'New errors: '.
		diff third do: [:s| str nextPutAll: s printString, ' '].
		str cr].
	
	Workspace new contents: string; openLabel: 'SUnit Progress'
	! !

!TestRunner methodsFor: 'history saving' stamp: 'stephane.ducasse 10/12/2008 19:24'!
showHistoryMenu
	| selectionIndex selectedPreviousResult actionIndex |
	selectionIndex := UIManager default chooseFrom: self historyMenuList title: 'History:'.

	"We pressed outside the menu"
	selectionIndex isZero ifTrue: [ ^ self ]. 				

	"save current result is selected"
	selectionIndex = 1 ifTrue: [ self previousRun addFirst: result. ^ self ]. 			

	selectedPreviousResult := self previousRun at: (selectionIndex - 1).
 	actionIndex := (UIManager default chooseFrom: #('delete' 'show diff')  title:  'Action:').
	actionIndex = 1 ifTrue: [ self previousRun remove: selectedPreviousResult. ^ self ].
	actionIndex = 2 ifTrue: [ self showDiffWith: selectedPreviousResult].	! !

!TestRunner methodsFor: 'history saving' stamp: 'AlexandreBergel 10/21/2008 15:57'!
showProgress
	| testCaseClasses d t string |
	testCaseClasses := (self suiteAll tests collect: [:testCase | testCase class]) asSet.
	
	"At the end of the algorithm, d will contains all the diff between what was saved and the current result"
	d := Dictionary new.
	d at: #passed put: OrderedCollection new.
	d at: #failures put: OrderedCollection new.
	d at: #errors put: OrderedCollection new.

	testCaseClasses do: [ :cls |
		(cls class methodDict includesKey: #lastRun)
			ifTrue: [t := cls lastStoredRun.
					(t at: #passed) do: [:s | 	
											(result isErrorFor: cls selector: s)
												ifTrue: [(d at: #errors) add: {cls . s}].
											(result isFailureFor: cls selector: s)
												ifTrue: [(d at: #failures) add: {cls . s}]  ].
											
					(t at: #failures) do: [:s | (result isPassedFor: cls selector: s)
												ifTrue: [(d at: #passed) add: {cls . s}].
											(result isErrorFor: cls selector: s)
												ifTrue: [(d at: #errors) add: {cls . s}]].
											
					(t at: #errors) do: [:s | 	(result isPassedFor: cls selector: s)
												ifTrue: [(d at: #passed) add: {cls . s}].
											(result isFailureFor: cls selector: s)
												ifTrue: [(d at: #failures) add: {cls . s}]]]].
		
			
	string := String streamContents: [:str|
		str nextPutAll: '----------------'; cr.
		str nextPutAll: 'Diff between current result and saved result'; cr.
		str nextPutAll: 'New passed: '.
		(d at: #passed) do: [:s| str nextPutAll: s printString, ' '].
		str cr.
		str nextPutAll: 'New failures: '.
		(d at: #failures) do: [:s| str nextPutAll: s printString, ' '].
		str cr.
		
		str nextPutAll: 'New errors: '.
		(d at: #errors) do: [:s| str nextPutAll: s printString, ' '].
		str cr].
	
	Workspace new contents: string; openLabel: 'SUnit Progress' string.

	! !

!TestRunner methodsFor: 'utilities' stamp: ''!
sortClass: t1 before: t2 
	| t3 t4 |
	t3 := t1 withAllSuperclasses reversed.
	t4 := t2 withAllSuperclasses reversed.
	1
		to: (t3 size min: t4 size)
		do: [:t5 | (t3 at: t5)
					== (t4 at: t5)
				ifFalse: [^ (t3 at: t5) name <= (t4 at: t5) name]].
	^ t4 includes: t1! !

!TestRunner methodsFor: 'accessing-testing' stamp: ''!
statusColor
	result hasPassed
		ifTrue: [^ Color green].
	result hasErrors
		ifTrue: [^ Color red].
	^ Color yellow! !

!TestRunner methodsFor: 'accessing-testing' stamp: ''!
statusText
	^ result printString! !

!TestRunner methodsFor: 'history saving' stamp: 'AlexandreBergel 10/21/2008 15:27'!
storeResultIntoClasses
	^ self storeResultIntoClassesUnderName: #lastStoredRun! !

!TestRunner methodsFor: 'history saving' stamp: 'AlexandreBergel 10/21/2008 15:30'!
storeResultIntoClassesUnderName: aSelector

	| testCaseClasses inst |
	testCaseClasses := (self suiteAll tests collect: [:testCase | testCase class]) asSet.
	testCaseClasses do: [:cls |
		inst := cls new.
		(inst isNecessaryToGenerateLastRunMethod: result)
			ifTrue: [inst generateLastRunMethodNamed: aSelector for: result]]! !

!TestRunner methodsFor: 'accessing' stamp: ''!
suiteAll
	^ TestSuite new
		in: [:t1 | 
			classesSelected
				do: [:t2 | t2 isAbstract
						ifFalse: [t2 addToSuiteFromSelectors: t1]].
			t1
				name: (self label: 'Test' forSuite: t1)]! !

!TestRunner methodsFor: 'accessing' stamp: ''!
suiteErrors
	^ TestSuite new
		in: [:t1 | t1 addTests: errorList;
				
				name: (self label: 'Error' forSuite: t1)]! !

!TestRunner methodsFor: 'accessing' stamp: ''!
suiteFailures
	^ TestSuite new
		in: [:t1 | t1 addTests: failedList;
				
				name: (self label: 'Failure' forSuite: t1)]! !

!TestRunner methodsFor: 'updating' stamp: ''!
update
	self updateCategories; updateClasses! !

!TestRunner methodsFor: 'updating' stamp: ''!
updateCategories
	categories := self findCategories.
	categoriesSelected := categoriesSelected isNil
				ifTrue: [Set new]
				ifFalse: [categoriesSelected
						select: [:t1 | categories includes: t1]].
	self changed: #categoryList;
		 changed: #categorySelected! !

!TestRunner methodsFor: 'updating' stamp: ''!
updateClasses
	| t1 |
	t1 := self findClassesForCategories: categoriesSelected.
	classes := t1 asArray
				sort: [:t2 :t3 | self sortClass: t2 before: t3].
	classesSelected := classesSelected isNil
				ifTrue: [t1]
				ifFalse: [classesSelected
						select: [:t4 | t1 includes: t4]].
	self changed: #classList;
		 changed: #classSelected;
		 changed: #hasRunnable! !

!TestRunner methodsFor: 'updating' stamp: 'AlexandreBergel 10/1/2008 23:09'!
updateResults
	"<lint: #expect rule: #guardingClause>"
	"<lint: #expect rule: #longMethods>"

	self updateStatus: false.
	failedList size = result failures size ifFalse: [
		failedList := result failures asArray
			sort: [ :a :b | a printString <= b printString ].
		failedSelected := nil.
		self 
			changed: #failedList; 
			changed: #failedSelected;
			changed: #hasFailures;
			changed: #hasProgress  ].
	errorList size = result errors size ifFalse: [
		errorList := result errors asArray
			sort: [ :a :b | a printString <= b printString ].
		errorSelected := nil.
		self 
			changed: #errorList; 
			changed: #errorSelected;
			changed: #hasErrors;
			changed: #hasProgress ].! !

!TestRunner methodsFor: 'updating' stamp: ''!
updateStatus: t1 
	(t1
			and: [lastUpdate = Time totalSeconds])
		ifTrue: [^ self].
	self changed: #statusText;
		 changed: #statusColor.
	lastUpdate := Time totalSeconds! !

!TestRunner methodsFor: 'private' stamp: ''!
windowIsClosing
	SystemChangeNotifier uniqueInstance noMoreNotificationsFor: self! !
TestRunner initialize!
